﻿using System;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Windows.Design.Interaction;
using Microsoft.Windows.Design.Model;

namespace Peer2PeerControlLibraryWPF.VisualStudio.Design
{
    /// <summary>
    /// 
    /// </summary>

    public partial class NetworkManagerDesignTimeControl : System.Windows.Controls.UserControl
    {
        public static readonly RoutedEvent ClosePopupEvent = EventManager.RegisterRoutedEvent("CloseNetworkPopupEvent", RoutingStrategy.Direct, typeof(RoutedEventHandler), typeof(NetworkManagerDesignTimeControl));

        public NetworkManagerDesignTimeControl()
        {
            InitializeComponent();
            
        }

       
        public event RoutedEventHandler ClosePopup
        {
            add { AddHandler(ClosePopupEvent, value); }
            remove { RemoveHandler(ClosePopupEvent, value); }
        }

        // This method raises the Tap event
        protected void RaiseSelectionChangedEvent()
        {
            RoutedEventArgs newEventArgs = new RoutedEventArgs(NetworkManagerDesignTimeControl.ClosePopupEvent);
            RaiseEvent(newEventArgs);
        }

        private void ItemsControl_Click(object sender, RoutedEventArgs e)
        {
            RaiseSelectionChangedEvent();
        }


        public ComboBox Audio
        {
            get{ return mAudioCombobox;}
        }

        public ComboBox Chat
        {
            get{ return mChatCombobox;}
        }

        public ComboBox File
        {
            get{ return mFileCombobox;}
        }

        public ComboBox Picture
        {
            get{ return mPictureCombobox;}
        }

        public ComboBox Video
        {
            get{ return mVideoCombobox;}
        }


        public ComboBox UserName
        {
            get { return mUserNameCombobox; }
        }

        public ComboBox NetworkName
        {
            get { return mNetworkNameCombobox; }
        }

        public ComboBox PasswordName
        {
            get { return mPasswordNameCombobox; }
        }

        public ComboBox SignInButton
        {
            get { return mSignInButtonCombobox; }
        }

        public ComboBox Status
        {
            get { return mStatusValueCombobox; }
        }

        private void _SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if(e.AddedItems.Count == 1)
            {
                RaiseSelectionChangedEvent();
            }
        }
    }
}