﻿using System;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Windows.Design.Interaction;
using Microsoft.Windows.Design.Model;

namespace Peer2PeerControlLibraryWPF.VisualStudio.Design
{
    /// <summary>
    /// Interaction logic for ColorsListControl.xaml
    /// </summary>

    public partial class PictureControlDesignTimeControl : System.Windows.Controls.UserControl
    {
        public static readonly RoutedEvent ClosePopupEvent = EventManager.RegisterRoutedEvent("ClosePicturePopupEvent", RoutingStrategy.Direct, typeof(RoutedEventHandler), typeof(ChatControlDesignTimeControl));

        public PictureControlDesignTimeControl()
        {
            InitializeComponent();
            
        }
       
        public event RoutedEventHandler ClosePopup
        {
            add { AddHandler(ClosePopupEvent, value); }
            remove { RemoveHandler(ClosePopupEvent, value); }
        }

        // This method raises the Tap event
        protected void RaiseSelectionChangedEvent()
        {
            RoutedEventArgs newEventArgs = new RoutedEventArgs(PictureControlDesignTimeControl.ClosePopupEvent);
            RaiseEvent(newEventArgs);
        }

        private void ItemsControl_Click(object sender, RoutedEventArgs e)
        {
            RaiseSelectionChangedEvent();
        }
                                         
        public ComboBox TitleNameCombobox
        {
            get{ return mTitleNameCombobox;}
        }

        public ComboBox FileNameCombobox
        {
            get { return mFileNameCombobox; }
        }

        public ComboBox ImageCombobox
        {
            get{ return mImageCombobox;}
        }

        public ComboBox SendPictureButtonCombobox
        {
            get { return mSendPictureButtonCombobox; }
        }
    
        private void _SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (e.AddedItems.Count == 1)
            {
                RaiseSelectionChangedEvent();
            }
        }
    }
}