﻿using System.ComponentModel.Design;
using System.Windows.Forms.Design;

namespace C4F.VistaP2P.Win.Chat
{
    /// <summary>
    /// This class is used to enable Design-Time features.
    /// </summary>
    public class ChatDesigner : ControlDesigner
    {
        /// <summary>
        /// returns the list of items to display in the smart tags.
        /// </summary>
        public override DesignerActionListCollection ActionLists
        {
            get
            {
                // Create action list collection
                DesignerActionListCollection actionLists = new DesignerActionListCollection();

                // Add custom action list
                actionLists.Add(new ChatDesignerActionList(this.Component));

                // Return to the designer action service
                return actionLists;
            }
        }               

        
        /// <summary>
        /// Helper property to acquire a ChatControl reference
        /// </summary>
        private ChatControl ChatControl
        {
            get { return (ChatControl)this.Component; }
        }
    }
}
