﻿using System.ComponentModel.Design;
using System.Windows.Forms.Design;

namespace C4F.VistaP2P.Win.File
{
    /// <summary>
    /// This class is used to enable Design-Time features.
    /// </summary>
    public class FileDesigner : ControlDesigner
    {
        /// <summary>
        /// returns the list of items to display in the smart tags.
        /// </summary>
        public override DesignerActionListCollection ActionLists
        {
            get
            {
                // Create action list collection
                DesignerActionListCollection actionLists = new DesignerActionListCollection();

                // Add custom action list
                actionLists.Add(new FileDesignerActionList(this.Component));

                // Return to the designer action service
                return actionLists;
            }
        }               
        
        /// <summary>
        /// Helper property to acquire a FileControl reference 
        /// </summary>
        private FileControl FileControl
        {
            get { return (FileControl)this.Component; }
        }
    }
}
